#include <libtools.h>
#include <anymap.h>
#include <thread>

typedef std::function<int(com::Anymap)> IntFunc;
typedef std::function<bool(com::Anymap)> BoolFunc;
typedef std::function<bool*(com::Anymap)> BoolArrFunc;  

IntFunc LoadEntry(std::string lib, std::string func) {
    DllHandle handler;
    return com::lib::loadFunction<int (com::Anymap), DllHandle>(lib.c_str(), func.c_str(), handler);
}

BoolFunc LoadPred(std::string lib, std::string func) {
    DllHandle handler;
    return com::lib::loadFunction<int (com::Anymap), DllHandle>(lib.c_str(), func.c_str(), handler);
}

BoolArrFunc LoadSelector(std::string lib, std::string func){
    DllHandle handler;
    return com::lib::loadFunction<std::list<bool> (com::Anymap), DllHandle>(lib.c_str(), func.c_str(), handler);
}

int main(int argc, char const *argv[])
{
    auto data = com::Anymap();
    auto predFunc = LoadPred("libprinters", "ReturnTrue"); 
    auto entrFunc = LoadEntry("libprinters", "PrintHello");
    auto selector = LoadSelector("libprinters", "ThreeTrue");
    std::list<bool> ST_selector_val;
    if (!predFunc(data)) {
        std::cout<<"Predicate returned FALSE on state ${}\n"; 
        goto TERM;
    }
    entrFunc(data);


    ST_selector_val = selector(data);
SELECTOR:
    if (ST_selector_val[0]) {
        ST_selector_val[0] = false;
        branch1();
    } else {
        goto NODE;
    }
    if(ST_selector_val[1]) {
        ST_selector_val[1] = false;
        ST2_selector_val = selector2(data);
        

        branch2();
    }
    else {
        goto NODE;
    }

NODE: 
    NODE_counter++;
    if NODE_counter == NODE_capacity{
        goto NEXT_NODE;
    } else {
        goto SELECTOR;
    }
TERM:
    std::cout<<"Termination!\n"; 
    return 0;
}